#ifndef __F81504_H__
#define __F81504_H__

#define DIM(var, type)  (sizeof(var)) / sizeof(type)

#define MODULE_PATH     "/sys/module/f81504_series/drivers/pci:f81504_pci2uart-4-8-12"
#define DEVICE_PATH     MODULE_PATH "/%s/tty" 

#define FIX_MODE        0xFF

#define LIST_FORMAT     "%-16s%-16s%-16s%-16s\n"
#define CFG_PORT_FORMAT "item%d_port"
#define CFG_MODE_FORMAT "item%d_mode"
#define CFG_MAX         16

/*---------------------------------------------------------------------------------*/
typedef struct
{
    char mode_str[16];
    char mode_int[4];
    int  cmd_mode;
    int  cmd_gpio;

} MODE_F81439_INFO;

typedef struct
{
    int  io_addr;
    char type[16];
    char mode[16];

} LIST_INFO;

typedef struct
{
    char              tty_port[16];
    MODE_F81439_INFO *mode;

    LIST_INFO         list_info; /* for list_port() */

} TTY_ITEM;


/*---------------------------------------------------------------------------------*/
static MODE_F81439_INFO mode_f81439_item[] =
{
    { "RS422",          "0",    -1,   0 },
    { "RS232",          "1",     1,   1 },
    { "RS485",          "2",     2,   2 },
    { "RS422R",         "4",    -1,   4 },
    { "RS485R",         "6",     2,   6 },
    { "Unsupported",   "-1",    -1,  -1 }
};

/*---------------------------------------------------------------------------------*/
int is_f81504 (char *tty_port);
int set_mode  (char *tty_port, int mode);
int set_gpio  (char *tty_port, int gpio);
int get_info  (char *tty_port, TTY_ITEM *item, int *current_gpio_mode);
int list_port (void);

#endif